'
'  xmltest.bas
'
'  test program to show simple use of dd_xml.bas
'  Compile with pbcc2.1 or greater
'
#compile exe
#dim all

#include "win32api.inc"
#include "dd_xml.bas"

$TEST_XML = _
      "<?xml version='1.0'?>" + $crlf + _
      "<root-node attrib1=""1"" attrib2=""2"">" + $crlf + _
      "<item1>This is item 1</item1>" + $crlf + _
      "<item2>This is item 2</item2>" + $crlf + _
      "</root-node>"

function pbmain

   Dim pXML as Dword
   Dim pFind as Dword
   Dim pRoot as Dword

   pXML = xmlParse($TEST_XML)
   if pXML = 0 then
      stdout "ERROR parsing: " + xmlLastError()
      goto pbmain_done
   end if

   '- Get the xml version
   pFind = xmlFindNode(pXML, 0, "?xml", "", "")
   if pFind = 0 then
      Stdout "Couldn't find a root-level node called '?xml'"
   else
      Stdout "XML Version=" + xmlAttribValue(pFind, "version")
   end if

   '- Find the root node
   pRoot = xmlFindNode(pXML, 0, "root-node", "", "")
   if pRoot = 0 then
      Stdout "Couldn't find root node"
   else
      Stdout "Found root node. Attrib2=" + xmlAttribValue(pRoot, "attrib2")

      '- Print the first data child of tag = item2
      pFind = xmlFindNode(pRoot, %XML_ANYWHERE, "item2", "", "")
      if pFind = 0 then
         Stdout "Unable to locate tag 'item2' under 'root-node'"
      else
         Stdout "Item 2's data=" + xmlChildData(pFind)
      end if

      '- Do it another way ...
      Stdout "item2 under root-node contains this child data:"
      Stdout xmlGetChildTagData(pRoot, "item2")
   end if


pbmain_done:
   if pXML then xmlFreePointers pXML
   Stdout "DONE. Press any key to exit"
   waitkey$

end function

